//+------------------------------------------------------------------+
//|                                                     cci bars.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 4
#property indicator_color1 Navy
#property indicator_color2 Red

#property indicator_color3 Navy
#property indicator_color4 Red

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

//---- input parameters
extern int MA_Period = 10;
extern int MA_Mode = 1;


//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double MUpBuffer[];
double MDnBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,MUpBuffer);
   SetIndexBuffer(3,MDnBuffer);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="MA Bars("+MA_Period+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,MA_Period);
   SetIndexDrawBegin(1,MA_Period);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), limit, shift;
  
   
   if(counted_bars<0) return(-1);
   limit=Bars-counted_bars;
    
   double fasterMAnow1, slowerMAnow1, fasterMAnow2, slowerMAnow2;
   
 for(shift=limit;shift>=0;shift--)
  {   	
	   fasterMAnow1 = iMA(NULL, 0, MA_Period, 0, MA_Mode, PRICE_CLOSE, shift);
      slowerMAnow1 = iMA(NULL, 0, MA_Period, 1, MA_Mode, PRICE_CLOSE, shift);
      fasterMAnow2 = iMA(NULL, 0, 5, 0, MODE_EMA, PRICE_CLOSE, shift);
      slowerMAnow2 = iMA(NULL, 0, 20, 0, MODE_EMA, PRICE_CLOSE, shift);

   	
      if ((fasterMAnow1 > slowerMAnow1) && (fasterMAnow2 > slowerMAnow2)) {
       MUpBuffer[shift]=1.0;
	    MDnBuffer[shift]=0; 
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
      else if (fasterMAnow1 > slowerMAnow1) {
	    UpBuffer[shift]=1.0;
	    DnBuffer[shift]=0; 
	    MUpBuffer[shift]=0;
	    MDnBuffer[shift]=0; 
	    }
	   else  if ((fasterMAnow1 < slowerMAnow1) && (fasterMAnow2 < slowerMAnow2)) {
	    MDnBuffer[shift]=1.0; 
	    MUpBuffer[shift]=0;
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
	   else if (fasterMAnow1 < slowerMAnow1) 
	    {
	     DnBuffer[shift]=1.0;
	     UpBuffer[shift]=0; 
	     MUpBuffer[shift]=0;
	     MDnBuffer[shift]=0; 
	    }
	 
	}
	return(0);	
 }

